/*
 * Copyright 1994, Brown University, Providence, RI
 *
 * Permission to use and modify this software and its documentation for
 * any purpose other than its incorporation into a commercial product is
 * hereby granted without fee.  Permission to copy and distribute this
 * software and its documentation only for non-commercial use is also
 * granted without fee, provided, however, that the above copyright notice
 * appear in all copies, that both that copyright notice and this permission
 * notice appear in supporting documentation, that the name of Brown
 * University not be used in advertising or publicity pertaining to
 * distribution of the software without specific, written prior permission,
 * and that the person doing the distribution notify Brown University of
 * such distributions outside of his or her organization. Brown University
 * makes no representations about the suitability of this software for
 * any purpose.  It is provided "as is" without express or implied warranty.
 * Brown University requests notification of any modifications to this
 * software or its documentation.
 *
 * Send the following redistribution information:
 *
 *      Name:
 *      Organization:
 *      Address (postal and/or electronic):
 *
 * To:
 *      Software Librarian
 *      Computer Science Department, Box 1910
 *      Brown University
 *      Providence, RI 02912
 *
 *              or
 *
 *      brusd@cs.brown.edu
 *
 * We will acknowledge all electronic notifications.
 */

/* -*-Mode:c++-*- */

//////////////////////////////////////////////////////////////////////////////
//                                                                          
//  NAME: Mitch Cherniack (mfc)		
//        Joon S. Lee (jl)
//
//  FILE: KOTWrap.H 
//  PROJ: KOLA
//  DATE: 8/97		                                                    
//
// SYNOPSIS
//  The type of TWrap objects.
//  
//////////////////////////////////////////////////////////////////////////////

#ifndef KOLA_TWRAP_HEADER
#define KOLA_TWRAP_HEADER 

#include "KGlobals.H"
#include "KONonType.H"
#include "KONameUnion.H"
#include "TYType.H"
#include "TYTObj.H"

class TWrap : public NonType
{
public:
  TWrap (TObj* ty);
  //Constructor.

  TWrap (const TWrap& other);
  // Copy Constructor.

  ~TWrap ();
  // Destructor

#ifdef _PROLOG_
  SP_term_ref sp_prolog () {return NULL;}
    // convert kola tree into prolog term and return it.
#endif // _PROLOG_

  char* prolog () {return _type->prolog();}

  char* representation (){return _type->representation();}

  TObj* Type () const;
  

  // dummy methods **********************************************************
  NonType* transform(CState* s) {return NULL;}

  int deepeq(NonType * other){return 0;}

  TWrap* Copy () const {return NULL;}
  
  NonType* Copy_kTree() const { return Copy(); }

  NameUnion* Myname(){return NULL;}

  int numChildren() const { return 0; }

  //  BResult* reduce () {return NULL;}

  int compares(NonType* nt, CState* a) {return 0;}

  int comparesSTM(NonType* nt, CState* a) {return 0;}

  void setDEPnInvDEP(char*, CState*) {}

  void undoSetInvDEP(char*, CState*) {}

  NonType* transformDeep(CState* s, CIEnvStackDataType* startingPt) {return NULL;}

  void replaceChild(NonType* child, int which_child) {}
 
  void initCurrChild() {}

  NonType* nextChild() {return NULL;}

  const char * Name() const { return NULL; }

  // dummy methods **********************************************************

  protected:
  
  TObj* _type;
};

#endif
