/*
 * Copyright 1994, Brown University, Providence, RI
 *
 * Permission to use and modify this software and its documentation for
 * any purpose other than its incorporation into a commercial product is
 * hereby granted without fee.  Permission to copy and distribute this
 * software and its documentation only for non-commercial use is also
 * granted without fee, provided, however, that the above copyright notice
 * appear in all copies, that both that copyright notice and this permission
 * notice appear in supporting documentation, that the name of Brown
 * University not be used in advertising or publicity pertaining to
 * distribution of the software without specific, written prior permission,
 * and that the person doing the distribution notify Brown University of
 * such distributions outside of his or her organization. Brown University
 * makes no representations about the suitability of this software for
 * any purpose.  It is provided "as is" without express or implied warranty.
 * Brown University requests notification of any modifications to this
 * software or its documentation.
 *
 * Send the following redistribution information:
 *
 *      Name:
 *      Organization:
 *      Address (postal and/or electronic):
 *
 * To:
 *      Software Librarian
 *      Computer Science Department, Box 1910
 *      Brown University
 *      Providence, RI 02912
 *
 *              or
 *
 *      brusd@cs.brown.edu
 *
 * We will acknowledge all electronic notifications.
 */

/* -*-Mode:c++-*- */

/*
 * Copyright 1994, Brown University, Providence, RI
 *
 * Permission to use and modify this software and its documentation for
 * any purpose other than its incorporation into a commercial product is
 * hereby granted without fee.  Permission to copy and distribute this
 * software and its documentation only for non-commercial use is also
 * granted without fee, provided, however, that the above copyright notice
 * appear in all copies, that both that copyright notice and this permission
 * notice appear in supporting documentation, that the name of Brown
 * University not be used in advertising or publicity pertaining to
 * distribution of the software without specific, written prior permission,
 * and that the person doing the distribution notify Brown University of
 * such distributions outside of his or her organization. Brown University
 * makes no representations about the suitability of this software for
 * any purpose.  It is provided "as is" without express or implied warranty.
 * Brown University requests notification of any modifications to this
 * software or its documentation.
 *
 * Send the following redistribution information:
 *
 *	Name:
 *	Organization:
 *	Address (postal and/or electronic):
 *
 * To:
 *	Software Librarian
 *	Computer Science Department, Box 1910
 *	Brown University
 *	Providence, RI 02912
 *
 *		or
 *
 *	brusd@cs.brown.edu
 *
 * We will acknowledge all electronic notifications.
 */


/* -*-Mode:c++-*- */

//////////////////////////////////////////////////////////////////////////////
//
// NAME: Mitch Cherniack (mfc@cs.brown.edu)					 	 
// FILE: PAParser.C
// PROJ: KOLA Parser, AQUA Translator
// DATE: 5/95
//
//////////////////////////////////////////////////////////////////////////////

#include "PAParser.H"

extern FILE *Kolain;
extern NonType *result;

int Kolaparse ();


//////////////////////////////////////////////////////////////////////////////
//                                                                          
// Function Name:  PAParser
// Parameters:	   char *					
// Returns:
//
// Constructor. Give name of file with query to parse as input.
//
//////////////////////////////////////////////////////////////////////////////

PAParser::PAParser (char *f)  {

  inp = NULL;
  setInput (f);
}

PAParser::PAParser()
{
  inp = stdin;
}

//////////////////////////////////////////////////////////////////////////////
//                                                                          
// Function Name:  ~PAParser
// Parameters:								  
// Returns:
//
// Destructor.
//         								    
//////////////////////////////////////////////////////////////////////////////

PAParser::~PAParser ()  {

  if (inp != NULL) fclose (inp);
}


//////////////////////////////////////////////////////////////////////////////
//                                                                          
// Function Name:  setInput
// Parameters:	   char *					
// Returns:
//
// Change the file to parse by this to f.
//         								    
//////////////////////////////////////////////////////////////////////////////

void
PAParser::setInput (char *f)  {

  if (inp != NULL) fclose (inp);

  inp = fopen (f, "r");
}


//////////////////////////////////////////////////////////////////////////////
//                                                                          
// Function Name:  parse
// Parameters:								  
// Returns: 	   KOObject *
//
// Parse the query contained in the current file, inp, and return the
// resulting KOLA tree.
//         								    
//////////////////////////////////////////////////////////////////////////////

NonType *
PAParser::parse ()  {

  if (inp != NULL) {

    int res = 0;
    Kolain = inp;

    if (!Kolaparse ()) {
      return result;
    } else {
      printf ("\nParse failed due to syntax error\n\n");
      return NULL;
    }
  } else  {

    printf ("Input File not found\n\n");
    return NULL;
  }
}



