/*
 * Copyright 1994, Brown University, Providence, RI
 *
 * Permission to use and modify this software and its documentation for
 * any purpose other than its incorporation into a commercial product is
 * hereby granted without fee.  Permission to copy and distribute this
 * software and its documentation only for non-commercial use is also
 * granted without fee, provided, however, that the above copyright notice
 * appear in all copies, that both that copyright notice and this permission
 * notice appear in supporting documentation, that the name of Brown
 * University not be used in advertising or publicity pertaining to
 * distribution of the software without specific, written prior permission,
 * and that the person doing the distribution notify Brown University of
 * such distributions outside of his or her organization. Brown University
 * makes no representations about the suitability of this software for
 * any purpose.  It is provided "as is" without express or implied warranty.
 * Brown University requests notification of any modifications to this
 * software or its documentation.
 *
 * Send the following redistribution information:
 *
 *      Name:
 *      Organization:
 *      Address (postal and/or electronic):
 *
 * To:
 *      Software Librarian
 *      Computer Science Department, Box 1910
 *      Brown University
 *      Providence, RI 02912
 *
 *              or
 *
 *      brusd@cs.brown.edu
 *
 * We will acknowledge all electronic notifications.
 */

/* -*-Mode:c++-*- */

//////////////////////////////////////////////////////////////////////////////
//                                                                          
//  NAME: Mitch Cherniack (mfc)					 	    
//  FILE: TYTSet.H 
//  PROJ: KOLA
//  DATE: 5/95		                                                    
//
// SYNOPSIS
//  Set Type Constructor.
//
//////////////////////////////////////////////////////////////////////////////

#ifndef KOLA_TSET_HEADER
#define KOLA_TSET_HEADER 

#include "../KGlobals.H"
#include "TYTObj.H"

#include <string.h>

class TSet : public TObj
{
    
 public:
  TSet (TObj* o);
  //  Constructor.
  
  TSet (TSet& other);
  //  Copy Constructor. 
  
  ~TSet ();
  //  Destructor. 

  TObj *Copy ();
  // Virtual Copy Constructor
    
  TObj* One () {return one;}
  //  What is the TObj that is the first argument?
      
  TSet* asSet () {return this;}
  // Coercer.

  koType* transformation () {return Copy();}    
  
  char *representation ();
  // Return textual representation of this    

  char* prolog ();
  // Return string representation of type in prolog term.

#ifdef _PROLOG_
  SP_term_ref sp_prolog ();
  // convert kola tree into prolog term and return it.
#endif // _PROLOG_

  int sameas (TObj *other) {return (other->Identity() == TYPE_ANY || (other -> Identity () == TYPE_SET && one->sameas(other->asSet()->One())));}
  // Set is same type as other set if both are sets of same type.
    
 protected:
  TObj* one;
  //  What object type are we forming a set of?
  
};


# endif

