/*
 * Copyright 1994, Brown University, Providence, RI
 *
 * Permission to use and modify this software and its documentation for
 * any purpose other than its incorporation into a commercial product is
 * hereby granted without fee.  Permission to copy and distribute this
 * software and its documentation only for non-commercial use is also
 * granted without fee, provided, however, that the above copyright notice
 * appear in all copies, that both that copyright notice and this permission
 * notice appear in supporting documentation, that the name of Brown
 * University not be used in advertising or publicity pertaining to
 * distribution of the software without specific, written prior permission,
 * and that the person doing the distribution notify Brown University of
 * such distributions outside of his or her organization. Brown University
 * makes no representations about the suitability of this software for
 * any purpose.  It is provided "as is" without express or implied warranty.
 * Brown University requests notification of any modifications to this
 * software or its documentation.
 *
 * Send the following redistribution information:
 *
 *      Name:
 *      Organization:
 *      Address (postal and/or electronic):
 *
 * To:
 *      Software Librarian
 *      Computer Science Department, Box 1910
 *      Brown University
 *      Providence, RI 02912
 *
 *              or
 *
 *      brusd@cs.brown.edu
 *
 * We will acknowledge all electronic notifications.
 */

/* -*-Mode:c++-*- */

//////////////////////////////////////////////////////////////////////////////
//
// NAME: Mitch Cherniack (mfc@cs.brown.edu)					 	 
// FILE: TYTUnk.C
// PROJ: KOLA Parser, AQUA Translator
// DATE: 5/95
//
//////////////////////////////////////////////////////////////////////////////

#include "TYTUnk.H"


//////////////////////////////////////////////////////////////////////////////
//                                                                          
// Function Name:  TUnk
// Parameters:	(char* n)							  
//
//  Constructor.  n is the name associated with this type
//         								    
//////////////////////////////////////////////////////////////////////////////

TUnk::TUnk (char* n)
{

    name = new char [strlen (n) + 1];
    sprintf (name, "%s", n);
    myname = TYPE_UNK;
    
}


//////////////////////////////////////////////////////////////////////////////
//                                                                          
// Function Name:  TUnk
// Parameters:	(char* n, char *n2)							  
//
//  Constructor.  n + n2 is the name associated with this type
//         								    
//////////////////////////////////////////////////////////////////////////////

TUnk::TUnk (char* n, char *n2)
{

    name = new char [strlen (n) + strlen (n2) + strlen (" ") + 1];
    sprintf (name, "%s %s", n, n2);
    myname = TYPE_UNK;
    
}


//////////////////////////////////////////////////////////////////////////////
//                                                                          
// Function Name:  TUnk
// Parameters:	(TUnk& other)							  
//
//  Copy Constructor.  
//         								    
//////////////////////////////////////////////////////////////////////////////

TUnk::TUnk (TUnk& other)
{

    name = new char [strlen (other . Name ()) + 1];
    sprintf (name, "%s", other . Name ());
    myname = TYPE_UNK;
    
}


//////////////////////////////////////////////////////////////////////////////
//                                                                          
// Function Name:  ~TUnk
// Parameters:	()
//
//  Destructor.  
//         								    
//////////////////////////////////////////////////////////////////////////////

TUnk::~TUnk ()
{
    
    delete [] name;
    
}


//////////////////////////////////////////////////////////////////////////////
//                                                                          
// Function Name:  representation
// Parameters:	()							  
//
//  return "VARIABLE: " + name
//         								    
//////////////////////////////////////////////////////////////////////////////

char* TUnk::representation ()
{
    
    char *res = new char [strlen (name) + 1];
    sprintf (res, "%s", name);
    return res;
    
}



//////////////////////////////////////////////////////////////////////////////
//                                                                          
// Function Name:  prolog
// Parameters:	()							  
//
//  return "VARIABLE: " + name
//         								    
//////////////////////////////////////////////////////////////////////////////

char* TUnk::prolog ()
{
  return NULL;
}

#ifdef _PROLOG_
//////////////////////////////////////////////////////////////////////////////
//
// Function Name:  sp_prolog
// Parameters:	()
//
// Since C/C++ functions only have indirect access to Prolog terms 
// via SP_term_refs, we need to convert kola tree to SP_term_refs.
// Converted kola tree will get passed to prolog runtime system.
//
// See the Sicstus prolog version 3#6 manual for more detailed info on
// the usage of SP_term_refs and other prolog supplied methods.
//
//////////////////////////////////////////////////////////////////////////////

SP_term_ref TUnk::sp_prolog ()
{
  return NULL;
}
#endif // _PROLOG_

//////////////////////////////////////////////////////////////////////////////
//                                                                          
// Function Name:  Copy
// Parameters:	()							  
//
//  return copy of this as TObj*
//         								    
//////////////////////////////////////////////////////////////////////////////

TObj* TUnk::Copy ()
{

    return new TUnk (*this);

}

